#version 330 core
//used to paint the texture on the screen:

//input data:
in  vec2 UV; //comes from vertex shader

//output data:
out vec3 color;

//values that stay constant for the whole mesh:
uniform sampler2D diffuseTexture;
uniform sampler2D DOFTexture1;
uniform sampler2D DOFTexture2;
uniform sampler2D DOFTexture3;
uniform sampler2D DOFTexture4;
uniform sampler2D DOFTexture5;
uniform sampler2D DOFTexture6;
uniform sampler2D DOFTexture7;
uniform sampler2D DOFTexture8;
uniform sampler2D DOFTexture9;
uniform sampler2D DOFTextureA;
uniform sampler2D DOFTextureB;
uniform sampler2D DOFTextureC;
uniform sampler2D DOFTextureD;
uniform sampler2D DOFTextureE;
uniform sampler2D DOFTextureF;

uniform int DOFSamples; //how many textures are valid!

void main()
{		
	//Output color = color of the texture at the specified UV
	vec3 accum = texture2D( diffuseTexture, UV ).rgb / (DOFSamples == 0 ? 1 : DOFSamples );
	
	switch( DOFSamples )
	{
	case 16:
		accum += texture2D( DOFTextureF, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 15:
		accum += texture2D( DOFTextureE, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 14:
		accum += texture2D( DOFTextureD, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 13:
		accum += texture2D( DOFTextureC, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 12:
		accum += texture2D( DOFTextureB, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 11:
		accum += texture2D( DOFTextureA, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 10:
		accum += texture2D( DOFTexture9, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 9:
		accum += texture2D( DOFTexture8, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 8:
		accum += texture2D( DOFTexture7, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 7:
		accum += texture2D( DOFTexture6, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 6:
		accum += texture2D( DOFTexture5, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 5:
		accum += texture2D( DOFTexture4, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 4:
		accum += texture2D( DOFTexture3, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 3:
		accum += texture2D( DOFTexture2, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
	case 2:
		accum += texture2D( DOFTexture1, UV ).rgb / DOFSamples;
		//allows fallthrough!!!!
		break;
	}
	
	color = accum;
}
