#version 330 core

//input data:
in  vec2 uv; //comes from vertex shader

//output data:
layout(location=0) out vec4 color;

//values that stay constant for the whole mesh:
uniform sampler2D textureSampler;
uniform vec4      colorSampler;
uniform int       DOFSamples;

void main()
{
	//Output color = color of the texture at the specified UV
	color = colorSampler * vec4(texture2D( textureSampler, uv ).rgb, 1);
}
